/**
 * Diese Klasse dient zur Zwischenspeicherung von Aktionen des Spielers wie
 * "dash" oder "turn", um eine Prognose ber die aktuelle Position des Spielers
 * erstellen zu knnen.
 *
 * @see Player
 * @see Memory
 * @author Gruppe 11 "DieElf"
 * @author <br>Ansprechpartner: <a href="mailto:fooxbox@web.de">Markus Fuchs</a>
 * @author <br>Ansprechpartner: <a href="mailto:rene@eDynamic.de">Ren Kubach</a>
 * @version $Id: ActionBuffer.java,v 1.3 2002/07/07 20:56:55 mf Exp $
 */
 
public class ActionBuffer
{
    private int    time;
    private String type;
    private double value;
 
	/** 
	 * Konstruktor, erzeugt einen neuen <code>ActionBuffer</code>
	 *
	 * @param time vom Typ <code>int</code>, Zeitpunkt der Aktion
	 * @param type vom Typ <code>String</code>, klassifiziert die Art der
	 * 		Aktion, z.B. "dash" oder "turn".
	 * @param value vom Typ <code>double</code>, Parameter, mit dem die Aktion
	 *		ausgefhrt wurde, z.B. Drehwinkel bei "turn".
	 */
    public ActionBuffer(int time, String type, double value)
    {
        this.time=time;
      	this.type=type;
      	this.value = value;
    }

    /** Zeitpunkt der Aktion */
    public int time()
    {
    	return time;
    }

    /** Art der Aktion */
    public String type()
    {
    	return type;
    }

	/**
	 * Parameter der Aktion
	 */
	 public double value()
	 {
	 	return value;
	 }
}