/**
 * Mit dieser Klasse werden Elf Spieler vom Typ <code>Player</code> initialisiert,
 * mit ihr wird der Client gestartet.
 * 
 * @see Player
 * @author Gruppe 11 "DieElf"
 * @author <br>Ansprechpartner: <a href="mailto:rene@eDynamic.de">Ren Kubach</a>
 * @author <br>Ansprechpartner: <a href="mailto:bernius@web.de">Christian Bernius</a>
 * @version $Id: DieElf.java,v 1.8 2002/07/07 20:56:55 mf Exp $
 */

public class DieElf {
	
	/** Servername */
	private static String servername = new String("localhost");
	/** Serverport */
	private static int port = 7000;
	/** Teamname */
	private static String teamName = new String("DieElf");
	/**
	 * (Interne) Nummer des Spielers mit aktivem Monitor; dabei liegen die
	 * internen Spielernummern zwischen 0 und 10. Alle anderen Nummern erzeugen
	 * <i>kein</k> Visualisierungsfenster.
	 */
	private static int playerWithMonitor = -1;
	
	/**
	 * Gibt Fehlermeldungen aus.<br>
	 * Knnte Sie veranlasst haben, diese Dokumentation zu ffnen ;-)
	 */
	private static void printError() {
		System.out.println("Eingabefehler!");
		System.out.println("Naehere Informationen zum Starten des Programmes\nfinden Sie im Handbuch oder der JavaDoc-Dokumentation");
		System.exit(1);	
	}
	
	/**
	 * Startet den Client.<br>
	 * Durch bergabe von Parametern beim Programmaufruf knnen nderungen an
	 * den Voreinstellungen vorgenommen werden:<br>
     * Kennt folgende Aufrufe:
     * <ul>
     * <li>(keine Paramenter, Standardeinstellungen werden bernommen)</li>
     * <li>playerWithMonitor</li>
     * <li>playerWithMonitor Servername Port Teamname</li>
     * </ul>
	 *
	 * @see DieElf#servername
	 * @see DieElf#port
	 * @see DieElf#teamName
	 * @see DieElf#playerWithMonitor
	 * @see Player
     * @param args[] (optional!!!)<br>
     */
		
	public static void main (String[] args){
		switch (args.length) {
			case 4:
				// ndere Servername...
				servername = args[1];
				// ... Serverport, wenn mglich, ...
				try {
					port = Integer.parseInt(args[2]);	
				} catch(NumberFormatException nfe) {
					printError();
				}
				// ... und Teamname
				teamName = args[3];
			case 1:
				// ndere Nummer des Spielers mit aktivem Monitor, wenn mglich
				try {
					playerWithMonitor = Integer.parseInt(args[0]);	
				} catch(NumberFormatException nfe) {
					printError();
				}
			case 0:
				// initialisiere elf Spieler
				for (int i=0; i<11; i++){
					boolean monitorActive = false;
					if(i==playerWithMonitor)
						monitorActive = true;
					int playersAreaNr = i;
					if (i==0){
						Kahn player = new Kahn(servername, port, teamName, playersAreaNr, monitorActive);
						player.start();
					}
					else {
						Player player = new Player(servername, port, teamName, playersAreaNr, monitorActive);
						player.start(); 
					}   
				}
				// gib Meldung ber Initialisierung aus.
				System.out.println("DieElf wurde gestartet...");
				System.out.println("Beenden Sie das Programm mit 'Strg' + 'c'");
			break;
			default:
				printError();
			break;
		}
	}
}
