/**
 * Diese Klasse stellt ein Spielfeld und alle sich darauf befindenden Objekte
 * dar.
 *
 * @see <code>Player</code>
 * @author Gruppe 11 "DieElf" 
 * @author <br>Ansprechpartner: <a href="mailto:suedpohl@web.de">Christof Pohl</a>, 
 * @author <br>Ansprechpartner: <a href="mailto:fornarina3112@gmx.de">Diana Wachsmann</a>
 * @version $Id: PlayerView.java,v 1.8 2002/07/07 21:44:45 mf Exp $
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;

 class PlayerView
 	extends JFrame
 	implements DocumentListener
 { /** Konstuktor PlayerView*/
 
 	/** Informationen ber den Spieler */
	public ObjectInfo myselfInfo;
	/** Informationen ber den Ball */
    public ObjectInfo ballInfo;
	/** Liste fr Informationen ber Mitspieler */
	public Vector teamMemberList = new Vector();
	/** Liste fr Informationen ber gegnerische Spieler */
	public Vector oponentList = new Vector();
	/** Char fr Site des eigenen Tors */
	public char mySide;
 
	//*Images zum Speichern der Daten*/ 
 	Image battlefield;
	Image ball;
	Image player;
	Image enemy;
	Image myself;
	JPanel playerPanel;

	
   public PlayerView(int playerNumber)
   { 
   	/** Setzen des Titels */
     super("PlayerView Player "+playerNumber);
     addWindowListener(new WindowAdapter()
     { 
     public void windowClosing(WindowEvent e)
        {
        	System.exit(0);
        }
     }   
     );
     
     Container contentPane = getContentPane();
     /** Panel anlegen*/
     playerPanel = new JPanel();
     /** PlayerWorld anlegen*/
     playerWorld = new PlayerWorld();
     contentPane.add(playerWorld, "Center");
     LoadAllPictures();
 	}
  /** wird aufgerufen, wenn etwas in das Dokument eingefgt wurde */
  public void insertUpdate(DocumentEvent e)
  {
  	repaint();
  }
  /** wird aufgerufen, wenn ein Teil des Dokuments entfernt wurde */
  public void removeUpdate(DocumentEvent e)
  {
  	repaint();
  }
  	/** wird aufgerufen, wenn sich ein Attribut gendert hat */
    public void changedUpdate(DocumentEvent e)
  {
  	repaint();
  }
  
  
  private PlayerWorld playerWorld;
  
  	public void LoadAllPictures()
	{
			
		/** Bildpfade werden gesetzt */
		String load_player = "player.gif";
		String load_battlefield = "feld.gif";
		String load_ball = "ball.gif";
		String load_enemy = "enemy.gif";
		String load_myself = "myself.gif";
		
		Toolkit kit= Toolkit.getDefaultToolkit();
		MediaTracker loadcontrol = new MediaTracker(this);
		
		/** Battlefield-Bild wird geladen */
		battlefield = kit.getImage(load_battlefield);
		loadcontrol.addImage(battlefield,0);
		
		try 
		{
			loadcontrol.waitForID(0);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Feld konnte nicht geladen werden!");
			return;
		}
		
		
		
			
		/** Ballbild wird geladen */
		ball = kit.getImage(load_ball);
		loadcontrol.addImage(ball,1);
	
		try 
		{
			loadcontrol.waitForID(1);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Ball konnte nicht geladen werden!");
			return;
		}
		
		/** Der ausgewhlte Spieler wird geladen */
		myself = kit.getImage(load_myself);
		loadcontrol.addImage(myself,2);
	
		try 
		{
			loadcontrol.waitForID(2);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Ausgewhlter Spieler konnte nicht geladen werden!");
			return;
		}
		
	
	
		
		
		/** Spielerbild wird geladen */
		player = kit.getImage(load_player);
		loadcontrol.addImage(player,4);
	
		try 
		{
			loadcontrol.waitForID(4);
		} 
		catch (InterruptedException e)
		{
			System.out.println("Player nicht geladen!");
			return;
		}
		
	
		
		/** Feindbild wird geladen */
		enemy = kit.getImage(load_enemy);
		loadcontrol.addImage(enemy,6);
	
		try 
		{
			loadcontrol.waitForID(6);
		} 
		catch (InterruptedException e)
		{
			System.out.println("enemy nicht geladen!");
			return;
		}

	
	
	}
  
  
     
 class PlayerWorld 
     	extends JPanel
 {
 	int check;


 	
 	/** Paint Methode */
 	public void paintComponent(Graphics g)
 	{ 
 		if(mySide == 'r')
 		check = -1; 
 		
 		else
 		check = 1;
 		
 		super.paintComponent(g);
 		/** Zeichnen des Spielfeldes*/
 		//System.out.println("spielersite" + mySide);
 		g.drawImage(battlefield,0,0,this);
  		
  		/** der ausgewaehlte Spieler wird hier gezeichnet*/
 		if(myselfInfo!=null) {
 			g.drawImage(myself,225+check*4*(int)myselfInfo.x(),151+check*4*(int)myselfInfo.y(),this);
 			}
 		else
 		{
 			//System.out.println("nicht da");
 			}
 			
 			
 			
 		/**Zeichnen des Balls */
 		if(ballInfo!=null) {
 			g.drawImage(ball,225+(check*4*(int)ballInfo.x()),151+(check*4*(int)ballInfo.y()),this);
 			}
 		else
 		{
 			//System.out.println("ball ist nicht da ");
 			}	
 		
 		/**Zeichnen des eigenen Teams*/
 		for(Enumeration e = teamMemberList.elements(); e.hasMoreElements();) {
				ObjectInfo oi = (ObjectInfo)e.nextElement();
				// z.B.: x-Koordinate des aktuellen teamMembers:
				g.drawImage(player,225+(check*4*(int)oi.x()),151+(check*4*(int)oi.y()),this);
				
		}
		/**Zeichnen der Gegner*/
		for(Enumeration e = oponentList.elements(); e.hasMoreElements();) {
				ObjectInfo oi = (ObjectInfo)e.nextElement();
				// z.B.: x-Koordinate des aktuellen teamMembers:
				g.drawImage(enemy,225+(check*4*(int)oi.x()),151+(check*4*(int)oi.y()),this);
				
		}
 			
 	}
 }
}

     
   
